var expectLog = []
var scriptTimer = null
var scriptTimeout = 0
var scriptStats = {}
var scriptRunning = false
var preparedEvents = []

function executeScript(lines) {
	videoPrint = function(message) {
		arrays["TEXTLINE$"][variables.CURSORY++] = message
		variables.CURSORX = 0
		textDirty = true
		
		expectLog.push((message.fmt) ? message.str : message)
	}
	
	scriptStats = {pass: 0, FAIL: 0, Skipped: 0}
	preparedEvents = []
	expectLog = []
	graphicTab()
	scriptRunning = true
	console.log("script starts")
	
	executeLines(lines, 1)
}

function executeLines(lines, offset) {
	for (var line in lines) {
		if (!cursorBlink) {
			setTimeout(function() { 
				executeLines(lines.slice(line), +line + offset)
			}, 100)
			
			return
		}

		if (scriptTimeout) {
			if (scriptTimer) {
				clearTimeout(scriptTimer)
			}

			scriptTimer = setTimeout(userBreak, scriptTimeout)
		}
		
		var message = executeScriptLine(lines[line])
		
		if (message) {
			console.log(message + "@" + (+line + offset))
			if (message in scriptStats) {
				scriptStats[message]++
			}
		}
	}

	console.log("script execution done")
	console.log(scriptStats)

	function countCoverage(map) {
		var total = 0
		var covered = 0
		for (i in map) {
			total++
			if (map[i].coverage) { covered++ }
		}
		return covered + " of " + total
	}

	console.log("instruction coverage: " + countCoverage(instructions))
	console.log("command coverage: " + countCoverage(commands))
	console.log("function coverage: " + countCoverage(builtInFunctions))
	console.log("operator coverage: " + countCoverage(operators))
	console.log("array coverage: " + countCoverage(builtInArrays))
	console.log("variable coverage: " + Object.keys(coveredVariables).length + " of " + Object.keys(builtInVariables).length)
	console.log("error coverage: " + Object.keys(coveredErrors).length)

	scriptRunning = false
}

function executeScriptLine(line) {
	if (line == "SCRIPT") {
	} else if (line.startsWith("TIMEOUT ")) {
		scriptTimeout = +line.substring(8)
	} else if (line.startsWith("EXPECT ")) {
		var arg = line.substring(7)

		for (var i in expectLog) {
			var logLine = expectLog[i]
			if (isNaN(arg)) {
				if (logLine != arg) {
					continue
				}
			} else {
				if (isNaN(logLine)) {
					continue
				}
				
				if (+arg != +logLine) {
					continue
				}
			}
			
			//match found at i: consume
			expectLog.splice(0, +i + 1)
			return "pass"
		}
		
		console.log("looking for " + arg)
		console.log("in expectLog of " + expectLog)		
		return "FAIL"
	} else if (line.startsWith("BETWEEN ")) {
		var args = line.split(" ")

		for (var i in expectLog) {
			var logLine = expectLog[i]

			if (isNaN(logLine)) {
				continue
			}

			if (+logLine < +args[1]) {
				continue
			}

			if (+logLine > +args[2]) {
				continue
			}
			
			expectLog.splice(0, +i + 1)
			console.log("found actual number " + logLine)
			return "pass"
		}
		
		console.log("number between " + args[1] + " and " + args[2])
		console.log("not found in " + expectLog)		
		return "FAIL"
	} else if (line == "PASS") {
		expectLog = []

		if (!parseSuccess) {
			console.log("unexpected parse error")
			return "FAIL"
		}

		if (inputAction != interact) {
			userBreak()
			console.log("test program not terminated when expected")
			return "FAIL"
		}

		if (variables.STATUS < 0) {
			console.log("unexpected error status")
			return "FAIL"
		}

		return "pass"
	} else if (line == "BREAK") {
		userBreak()
	} else if (line.startsWith("ENTER ") || line == "ENTER") {  // in case one wants to enter PASS
		userInputValue = line.substring(6)
		userInput()
		eventHandler()
	} else if (line == "" && inputAction == interact) {
		taList.value += "\n"
	} else if (line.startsWith("UNEXPECT")) {
		var arg = line.substring(9)

		for (var i in expectLog) {
			var logLine = expectLog[i]
			if (isNaN(arg)) {
				if (logLine != arg) {
					continue
				}
			} else {
				if (isNaN(logLine)) {
					continue
				}
				
				if (+arg != +logLine) {
					continue
				}
			}
			
			//match found at i: fail
			console.log("unexpected line " + arg)
			return "FAIL"
		}
		
		return "pass"
	} else if (line.startsWith("BUFFER ")) {
		preparedEvents = line.split(" ").slice(1)
	} else if (line == "RUN") {
		stopped = labels.START
		instructions.CLR.run(0)
	
		eventQueue = preparedEvents
	
		contProgram()
	} else {
		userInputValue = line
		userInput()
		eventHandler()
	}
}

